# Copyright information in version.rb
#
require 'dotenv'
require 'pathname'
require 'logger'
require 'fileutils'
require 'hov/version'
require 'hov/config'
require 'hov/command'
require 'hov/logging'
# Gem is wrapped in Hov module
module Hov
  # global variables and environment initialization
  class << self
    attr_accessor :config
    attr_accessor :log

    # source root global
    def source_root
      @source_root ||= Pathname.new(File.expand_path('../../', __FILE__))
    end

    # directory where command is being executed, typically the platform definition
    def root_dir
      @root_dir = Dir.pwd
    end
  end
end

# Global logging variables
Hov.config = Hov::Config.new
Hov.log = Hov::Logging::MultiLogger.new(Hov.config.stdout_log,
                                        Hov.config.local_log,
                                        Hov.config.remote_log)
