# Copyright information in version.rb
require 'thor'
require 'hov'
# comment
module Hov
  # Command Line Interface
  class CLI < Thor
    # single function to include required files and process request based on parameters
    module RunCommands
      # pull in desired command file based on param
      def do_command(command, action, args, options)
        require "hov/commands/#{command}"

        cmd = Hov::Command.const_get(Thor::Util.camel_case(command))
        cmd.new(action, args, options).call
      end
    end

    include RunCommands

    def initialize(*args)
      super
      # $stdout.sync = true
    end

    desc 'version, -v', 'Print hov version information'
    map %w(-v --version) => :version
    def version
      puts "hov #{Hov::VERSION}"
    end

    desc 'init PRODUCT', 'Initialize a new hov defined platform by creating template files'
    def init(*args)
      do_command('init', 'init', args, options)
    end
  end
end
